
signature LEXER =
sig

    datatype token =
        INT
      | BOOL
      | ARROW
      | TRUE
      | FALSE
      | FUN
      | IS
      | END
      | IF
      | THEN
      | ELSE
      | FI
      | COMMA
      | LPAREN
      | RPAREN
      | SEMICOLON
      | EQUALS
      | TIMES
      | MINUS
      | NEGATE
      | PLUS
      | COLON
      | NUMBER of int
      | VAR of string

    val lex : char Stream.stream -> token Stream.stream

    val tokenToString : token -> string

end