signature PARSE =
sig

  (* parser for MinML programs.
   
     A MinML program is an expression followed by a semicolon;
     this function takes an input stream of tokens and returns
     a stream of programs (expressions).
   *)

  val parse : Lexer.token Stream.stream -> DBMinML.exp Stream.stream

  exception ParseError of string

end
