signature PRINT =
sig
  type typ
  type exp

  (* print a type *)
  val typToString : typ -> string

  (* print an expression *)
  val expToString : exp -> string
end

signature NAMEDPRINT = PRINT 
    where type typ = MinML.typ
    and type exp = MinML.exp

signature DBPRINT = PRINT 
    where type typ = DBMinML.typ
    and type exp = DBMinML.exp
