signature TYPING =
sig

  exception TypeError

  (* computes the type of an expression, or raises TypeError if
     no type exists *)
  val typeOf : DBMinML.exp -> DBMinML.typ

  (* ... NONE if no type exists *)
  val typeOpt : DBMinML.exp -> DBMinML.typ option

end
