structure Typing :> TYPING =
struct

  open DBMinML

  exception TypeError


  (* Assert two types are the same. *)

  fun equal (t,t') = ...

  (**** Type Environments ****)

  type 'a env = 'a list

  (* The empty environment. *)
  val empty = nil

  (* (g++t) adds a DeBruijn variable (1) with type t 
     to environment g. *)
  (* ++ : ('a env) * 'a -> ('a env) *)
  infix 1 ++
  fun (g ++ t) = ...

  (* lookup finds the type of a variable (i) or raises TypeError *)
  (* lookup : ('a env) -> var -> 'a *)
  fun lookup r i = 
      ...


  (**** Type Checking ****)

  (* typing(g,e) returns the type of e in context g, or raises
     TypeError if e has no type in context g. *)
  (* typing : (typ env) * exp -> typ *)

  fun typing (_,Int _) = INT
    | typing ...
























  (* these are already complete, given a working typing function *)

  fun typeOf e = typing(empty,e)
  fun typeOpt e = SOME (typeOf e) handle TypeError => NONE

end
